"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.htmlWebpackPluginTemplateCustomizer = void 0;
var fs_1 = require("fs");
var ejs_1 = require("ejs");
var requireFunction = function (requestPath) {
    if (requestPath.endsWith('.json')) {
        return JSON.parse((0, fs_1.readFileSync)(requestPath, 'utf-8'));
    }
    else {
        return require(requestPath);
    }
};
var resolveRequirePaths = function (context, content) { return __awaiter(void 0, void 0, void 0, function () {
    var requirePattern, resultContent, matches, matchFilename, requestSource, result;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                requirePattern = /<%[_\W]?.*(require\(.*\)).*[_\W]?%>/g;
                resultContent = content;
                matches = requirePattern.exec(content);
                _a.label = 1;
            case 1:
                if (!matches) return [3 /*break*/, 4];
                matchFilename = matches[1].match(/(['"`])[^'"`]*\1/);
                requestSource = matchFilename !== null ? matchFilename[0].replace(/['"`]/g, '') : null;
                if (!(requestSource !== null)) return [3 /*break*/, 3];
                return [4 /*yield*/, context.getResolve()(context.context, requestSource)];
            case 2:
                result = _a.sent();
                resultContent = resultContent.replace(matches[1], "require('".concat(result, "')"));
                _a.label = 3;
            case 3:
                matches = requirePattern.exec(content);
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/, resultContent];
        }
    });
}); };
// Since Node.js had marked the querystring as legacy API in version 14.x, and recommended using URLSearchParams,
// we should migrate from "querystring" to "URLSearchParams" if we want to get URL query string here.
// check this: https://www.linkedin.com/pulse/how-migrate-from-querystring-urlsearchparams-nodejs-vladim%C3%ADr-gorej?trk=articles_directory
// eslint-disable-next-line @typescript-eslint/no-explicit-any
var obj2URLQueryString = function (config) {
    if (!config)
        return '';
    var optionArr = [];
    Object.keys(config).forEach(function (key) {
        var optionItem = [key, JSON.stringify(config[key])];
        optionArr.push(optionItem);
    });
    return new URLSearchParams(optionArr).toString();
};
function htmlWebpackPluginTemplateCustomizer(config) {
    var htmlLoader = "".concat(require.resolve('html-loader')); // get html-loader entry path
    var templateEjsLoader = "".concat(require.resolve('template-ejs-loader')); // get template-ejs-loader entry path
    var htmlLoaderOption = "".concat(obj2URLQueryString(config.htmlLoaderOption)); // get html-loader option
    var templateEjsLoaderOption = "".concat(obj2URLQueryString(config.templateEjsLoaderOption)); // get template-ejs-loader option
    // Check if option string is empty; (And if it's not, prepend a questionmark '?');
    // This usage is about webpack loader inline, you can check the spec here : https://webpack.js.org/concepts/loaders/#inline
    if (htmlLoaderOption) {
        htmlLoaderOption = "?".concat(htmlLoaderOption);
    }
    if (templateEjsLoaderOption) {
        templateEjsLoaderOption = "?".concat(templateEjsLoaderOption);
    }
    // combile loaders/loader options/templatePath then generate customized template name
    return "!".concat(htmlLoader).concat(htmlLoaderOption, "!").concat(templateEjsLoader).concat(templateEjsLoaderOption, "!").concat(config.templatePath);
}
exports.htmlWebpackPluginTemplateCustomizer = htmlWebpackPluginTemplateCustomizer;
function ejsLoader(content, sourceMap, additionalData) {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function () {
        var callback, loaderOptions, originalIncluder, customizeIncluder, ejsOptions, currentHtmlWebpackPlugin, templateParameters, parameter, resolveContent, template, error_1;
        var _this = this;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    callback = this.async();
                    loaderOptions = this.getOptions();
                    if (loaderOptions.data !== undefined && typeof loaderOptions.data === 'string') {
                        Object.assign(loaderOptions, { data: JSON.parse(loaderOptions.data) });
                    }
                    originalIncluder = (_a = loaderOptions.includer) !== null && _a !== void 0 ? _a : null;
                    customizeIncluder = function (originalPath, parsedPath) {
                        _this.addDependency(parsedPath);
                        if (originalIncluder !== null) {
                            return originalIncluder(originalPath, parsedPath);
                        }
                        else {
                            return {
                                filename: parsedPath
                            };
                        }
                    };
                    loaderOptions.includer = customizeIncluder;
                    ejsOptions = Object.assign({
                        filename: this.resourcePath
                    }, loaderOptions);
                    if (Object.keys((_b = loaderOptions.data) !== null && _b !== void 0 ? _b : {}).includes('require')) {
                        callback(Error('Do not set "require" in the loader options'));
                    }
                    currentHtmlWebpackPlugin = (_c = this._compiler) === null || _c === void 0 ? void 0 : _c.options.plugins.filter(function (plugin) {
                        return typeof plugin === 'object' &&
                            plugin.options &&
                            plugin.options.template &&
                            plugin.options.template === _this.resource;
                    })[0];
                    templateParameters = {};
                    if (typeof currentHtmlWebpackPlugin === 'object' &&
                        typeof currentHtmlWebpackPlugin.options.templateParameters !== 'function') {
                        Object.assign(templateParameters, {
                            htmlWebpackPlugin: {
                                options: currentHtmlWebpackPlugin.options.templateParameters
                            }
                        });
                    }
                    parameter = Object.assign({
                        require: function (source) { return requireFunction(source); }
                    }, loaderOptions.data, templateParameters);
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, resolveRequirePaths(this, content)];
                case 2:
                    resolveContent = _d.sent();
                    return [4 /*yield*/, (0, ejs_1.compile)(resolveContent, ejsOptions)(parameter)];
                case 3:
                    template = _d.sent();
                    callback(null, template, sourceMap, additionalData);
                    return [3 /*break*/, 5];
                case 4:
                    error_1 = _d.sent();
                    callback(error_1);
                    return [3 /*break*/, 5];
                case 5: return [2 /*return*/];
            }
        });
    });
}
exports["default"] = ejsLoader;
